// leech_tool:
//
//		Tool to download an "<author>\n<url>\n<author>\n<url>\n"... file list and then
//		put each file under the correct author folder.
//
//		It was built to work with Indie Asset Organizer and
//		download everything using the Assembleech script (by "Sos", Thanks to you!)
//
// Released under the Creative Commons Attribution-Noncommercial-Share Alike 3.0 license.
//
// You need to have wget on the same folder where this is run from.
// 
// -nitram_cero [ www.2bam.com ]

#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <list>
#include <sstream>
#include <ctype.h>
using namespace std;

#define VERSION				"v1.2"
#define URL_LEECH			"http://so0os.pl/assembleech/wget.txt"
#define TEMP_LIST			"./temp-list.txt"


//composite string, ret code
list<pair<string, int> > failed;

const char * const wgetExitCodes[] = {
    "No problems occurred.",
    "Generic error code.",
    "Parse errorfor instance, when parsing command-line options, the .wgetrc or .netrc...",
    "File I/O error.",
    "Network failure.",
    "SSL verification failure.",
    "Username/password authentication failure.",
    "Protocol errors.",
    "Server issued an error response.",
};

/*bool exists(const string &author, const string &file)
{
	stringstream fn;
	fn << "./assets/" << author << "/" << file;
	ifstream is(fn.str().c_str());
	return !is.fail();
}*/

void getFile(const string &author, const string &url)
{
	string::size_type slash=url.find_last_of('/');
	string filename = slash != string::npos ? url.substr(slash+1) : url;

	cout << author << "'s " << filename << "...";

	//quiet, no continue, no host directories and output to author directory
	stringstream call;
	//call << "wget -q -c -nH -P ./assets/" << author << "/ " << url;
	//I removed continuation because it worked like crap. By default wget retries 20 times so it's ok.
	call << "wget -q -nH -P \"./assets/" << author << "/\" \"" << url << "\"";
	

	int ret;
	//Check if it returned an error AND if the file exists (404/non-direct-link pages return an htm)
	if((ret=system(call.str().c_str())) != 0 /*|| !exists(author, filename)*/) {
		stringstream failStr;
		failStr << author << "'s " << url;
		failed.push_back(make_pair(failStr.str(), ret));
		cout << "FAIL (" << ret << ")" << endl;
	}
	else
		cout << "OK" << endl;
}

bool getList()
{
	cout << "Retrieving full list..." << endl;
	int ret;
	//quiet and output to specific path
	if((ret=system("wget -q -O " TEMP_LIST " " URL_LEECH)) != 0) {
		cout << "Couldn't retrieve list. wget error "<<ret<<(0<=ret && ret<=8 ? wgetExitCodes[ret] : "???")<<endl;
		return false;
	}

	ifstream flist(TEMP_LIST);
	string author;
	string url;
	while(!flist.eof()) {
		getline(flist, author);
		getline(flist, url);

		//Fix to work with IAO
		for(string::size_type i=0; i<author.length(); i++) {
			if(isspace(author[i]))
				author[i] = '_';
		}

		getFile(author, url);
	}

	return true;
}



int main()
{
	cout << "leech_tool " VERSION ": download everything from the assembleech by \"Sos\"" << endl;
	cout << "			to Indie Asset Organizer compatible folders" << endl;
	cout << endl;
	cout << "Links must be direct for this to work" << endl;
	cout << "Failed links will be listed last" << endl;
	cout << endl;
	cout << "Tool by nitram_cero. Go drink some coffee now :)\n" << endl;
	cout << endl;

	if(!getList())
		return 1;

	cout << "================== FAILED LIST ==================" << endl;
	for(list<pair<string, int> >::iterator it = failed.begin(); it != failed.end(); ++it) {
		cout << "FAILED(" << " - " << it->second
			<< ": " << (0<=it->second && it->second<=8 ? wgetExitCodes[it->second] : "???")
			<< "): " << it->first << endl;
	}

	cout << endl << "Press enter to exit" << endl;
	getchar();	//Mac friendly I believe.
	return 0;
}
